function [Voltage]=voltage_extraction(BusNames,NodeNames,k)


lb=length(BusNames);
ln=length(NodeNames);

for x=1:lb
    node1=[BusNames{x},'.1'];
    node2=[BusNames{x},'.2'];
    node3=[BusNames{x},'.3'];
    node4=[BusNames{x},'.4'];
    VNn(x)=0;
   
    for j=1:ln
        pha=strcmp(node1,NodeNames{j});
        if pha==1
            VAn(x)=k((2*j)-1)+1i*k(2*j);
        end
    end
    
    for j=1:ln
        phb=strcmp(node2,NodeNames{j});
        if phb==1
            VBn(x)=k((2*j)-1)+1i*k(2*j);
        end
    end
    
    for j=1:ln
        phc=strcmp(node3,NodeNames{j});
        if phc==1
            VCn(x)=k((2*j)-1)+1i*k(2*j);
        end
    end
    
    for j=1:ln
        neutral=strcmp(node4,NodeNames{j});
        if neutral==1
            VNn(x)=k((2*j)-1)+1i*k(2*j);
        end
    end
    
end
    
Voltage.VAN_vec=VAn-VNn;
Voltage.VBN_vec=VBn-VNn;
Voltage.VCN_vec=VCn-VNn;

